package es.rickyepoderi.sample;

import java.security.Principal;
import javax.ejb.Stateless;
import javax.jws.WebMethod;
import javax.jws.WebService;
import javax.jws.soap.SOAPBinding;
import org.apache.cxf.annotations.Policy;
import org.apache.cxf.message.Message;
import org.apache.cxf.phase.PhaseInterceptorChain;
import org.apache.cxf.security.SecurityContext;
import org.jboss.ws.api.annotation.EndpointConfig;

/**
 *
 * @author rickyepdoeri
 */
@Stateless
@WebService(name = "echo", 
        targetNamespace = "http://es.rickyepoderi.sample/ws", 
        serviceName = "echo-service")
@Policy(placement = Policy.Placement.BINDING, uri = "WssSamlV20Token11.xml")
@SOAPBinding(style = SOAPBinding.Style.RPC)
@EndpointConfig(configFile = "WEB-INF/jaxws-endpoint-config.xml", configName = "Custom WS-Security Endpoint")
public class Echo {

    @WebMethod
    public String echo(String input) {
        Message message = PhaseInterceptorChain.getCurrentMessage();
        SecurityContext context = message.get(SecurityContext.class);
        Principal caller = null;
        if (context != null) {
            caller = context.getUserPrincipal();
        }

        return (caller == null? "null" : caller.getName()) + " -> " +  input;
    }
}