/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package es.rickyepoderi.sample;

import java.io.IOException;
import java.io.PrintWriter;
import java.net.URISyntaxException;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.keycloak.adapters.saml.SamlPrincipal;
import org.keycloak.dom.saml.v2.assertion.AssertionType;
import org.keycloak.saml.validators.ConditionsValidator;
import org.keycloak.saml.validators.DestinationValidator;

/**
 *
 * @author rickyepoderi
 */
@WebServlet(name = "EchoServlet", urlPatterns = {"/EchoServlet"})
public class EchoServlet extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        String input = request.getParameter("input");
        if (input == null) {
            input = "something....";
        }
        try {
            WSClient client = new WSClient(request);
            // re-check the assertion to see if still valid
            AssertionType assertion = ((SamlPrincipal) request.getUserPrincipal()).getAssertion();
            ConditionsValidator validator = new ConditionsValidator.Builder(assertion.getID(), assertion.getConditions(),
                    DestinationValidator.forProtocolMap(null))
                    .addAllowedAudience(client.getUri())
                    .build();
            if (!validator.isValid()) {
                // perform a local logout and force the re-authentication against the keycloak server
                request.logout();
                if (request.getSession() != null) {
                    request.getSession().invalidate();
                }
                response.sendRedirect(request.getContextPath() + "/");
            } else {
                try (PrintWriter out = response.getWriter()) {
                    response.setContentType("text/html;charset=UTF-8");
                    out.println("<!DOCTYPE html>");
                    out.println("<html>");
                    out.println("<head>");
                    out.println("<title>Servlet EchoServlet</title>");
                    out.println("</head>");
                    out.println("<body>");
                    out.println("<h1>Servlet EchoServlet at " + request.getContextPath() + "</h1>");
                    out.println(client.callEcho(((SamlPrincipal) request.getUserPrincipal()).getAssertionDocument(), input));
                    out.println("<p><a href=\"index.jsp\">back</a></p>");
                    out.println("</body>");
                    out.println("</html>");
                }
            }
        } catch (URISyntaxException e) {
            throw new ServletException(e);
        }
    }

    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Echo Servlet";
    }

}
