/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package es.rickyepoderi.sample;

import java.net.MalformedURLException;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import javax.servlet.http.HttpServletRequest;
import javax.xml.ws.BindingProvider;
import org.apache.cxf.rt.security.SecurityConstants;
import org.w3c.dom.Document;
import sample.rickyepoderi.es.ws.Echo;
import sample.rickyepoderi.es.ws.EchoService;

/**
 *
 * @author rickyepdoeri
 */
public class WSClient {

    private final URL url;

    public WSClient(HttpServletRequest req) throws MalformedURLException {
        url = new URL(new StringBuilder()
                .append(req.getScheme()).append("://")
                .append(req.getServerName())
                .append(":")
                .append(req.getServerPort())
                .append(req.getContextPath())
                .append("/echo-service/echo?wsdl")
                .toString());
    }

    public URI getUri() throws URISyntaxException {
        return new URI(url.getProtocol(),
                url.getAuthority(),
                url.getPath(),
                null,
                null);
    }

    public String callEcho(Document assertion, String input) {
        EchoService service = new EchoService(url);
        Echo echo = service.getEchoPort();
        // Properties for WS-Security configuration
        ((BindingProvider)echo).getRequestContext().put(SecurityConstants.SAML_CALLBACK_HANDLER,
                new KeycloakSamlCallbackHandler(assertion));
        // call the endpoint
        return echo.echo(input);
    }
}
